from enum import Enum
from .models import *
from .base_model import Page
from .services.allowlists import Allowlists
from .services.blocklists import Blocklists
from .services.integrations import Integrations
from .services.info import Info
from .services.metrics import Metrics
from .services.hub import Hub
from .http_client import ApiKeyAuth

class Server(Enum):
    production_server = 'https://admin.api.crowdsec.net/v1/'

__all__ = [
    'Allowlists',
    'Blocklists',
    'Integrations',
    'Info',
    'Metrics',
    'Hub',
    'AllowlistCreateRequest',
    'AllowlistCreateResponse',
    'AllowlistGetItemsResponse',
    'AllowlistGetResponse',
    'AllowlistItemUpdateRequest',
    'AllowlistItemUpdateResponse',
    'AllowlistItemsCreateRequest',
    'AllowlistScope',
    'AllowlistSubscriberEntity',
    'AllowlistSubscribersCount',
    'AllowlistSubscriptionRequest',
    'AllowlistSubscriptionResponse',
    'AllowlistUpdateRequest',
    'AllowlistUpdateResponse',
    'ApiKeyCredentials',
    'AttacksMetrics',
    'BasicAuthCredentials',
    'BlocklistAddIPsRequest',
    'BlocklistCategory',
    'BlocklistContentStats',
    'BlocklistCreateRequest',
    'BlocklistDeleteIPsRequest',
    'BlocklistIncludeFilters',
    'BlocklistOrigin',
    'BlocklistSearchRequest',
    'BlocklistShareRequest',
    'BlocklistSources',
    'BlocklistStats',
    'BlocklistSubscriberEntity',
    'BlocklistSubscribersCount',
    'BlocklistSubscription',
    'BlocklistSubscriptionRequest',
    'BlocklistSubscriptionResponse',
    'BlocklistUpdateRequest',
    'BlocklistUsageStats',
    'Body_uploadBlocklistContent',
    'ComputedMetrics',
    'ComputedSavedMetrics',
    'CtiAs',
    'CtiBehavior',
    'CtiCategory',
    'CtiCountry',
    'CtiIp',
    'CtiScenario',
    'EntityType',
    'GetRemediationMetricsResponse',
    'HTTPValidationError',
    'InfoResponse',
    'IntegrationCreateRequest',
    'IntegrationCreateResponse',
    'IntegrationGetResponse',
    'IntegrationType',
    'IntegrationUpdateRequest',
    'IntegrationUpdateResponse',
    'Links',
    'MetricUnits',
    'OriginMetrics',
    'OutputFormat',
    'PageTAnyCustomizedAllowlistGetItemsResponse',
    'PageTAnyCustomizedAllowlistGetResponse',
    'PageTAnyCustomizedAllowlistSubscriberEntity',
    'PageTAnyCustomizedBlocklistSubscriberEntity',
    'PageTAnyCustomizedIntegrationGetResponse',
    'PageTAnyCustomizedPublicBlocklistResponse',
    'Permission',
    'PricingTiers',
    'PublicBlocklistResponse',
    'PublicPaginatedBlocklistResponse',
    'RawMetrics',
    'RemediationMetrics',
    'RemediationMetricsData',
    'Share',
    'SourceInfo',
    'SourceType',
    'Stats',
    'SubscriberEntityType',
    'ValidationError',
    'AppsecConfigIndex',
    'AppsecRuleIndex',
    'CollectionIndex',
    'ContextIndex',
    'Index',
    'ParserIndex',
    'PostoverflowIndex',
    'ScenarioIndex',
    'VersionDetail',
    'ApiKeyAuth',
    'Server',
    'Page'
]